# authentic2 - versatile identity manager
# Copyright (C) 2010-2020 Entr'ouvert
#
# This program is free software: you can redistribute it and/or modify it
# under the terms of the GNU Affero General Public License as published
# by the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


def _json_value(value):
    if isinstance(value, (dict, list, str, int, bool)) or value is None:
        return value
    return str(value)


def form_to_old_new(form):
    old = {}
    new = {}
    for key in form.changed_data:
        old_value = form.initial.get(key)
        if old_value is not None:
            old[key] = _json_value(old_value)
        new[key] = _json_value(form.cleaned_data.get(key))
    return {'old': old, 'new': new}
